package cnf;

import static org.junit.Assert.*;

import org.junit.Test;
import cnf.*;

public class _test_Clause {

	@Test
	public void test_empty_clause() {
		Clause c = new Clause();
		assertEquals(c.eval(new Environment()), Bool.UNDEFINED);
	}
	
	@Test
	public void test_single_literal() {
		Clause c = new Clause();
		Literal l = new Literal(0);
		Environment e = new Environment();
		c.add(l);
		e.add(0, Bool.TRUE);
		
		assertEquals(c.eval(e), Bool.TRUE);
	}
	
	@Test
	public void test_negated_literal() {
		Clause c = new Clause();
		Literal l = new Literal(0);
		l.negate();
		c.add(l);
		Environment e = new Environment();
		e.add(0, Bool.TRUE);
		
		assertEquals(c.eval(e), Bool.FALSE);
	}
	
	@Test
	public void test_1000_true_literals() {
		Clause c = new Clause();
		Environment e = new Environment();
		for(int i=0; i<1000; i++)
		{
			Literal l = new Literal(i);
			e.add(i, Bool.TRUE);
			c.add(l);
		}
		assertEquals(c.eval(e), Bool.TRUE);
	}
	
	@Test
	public void test_all_true_but_one_literals() {
		Clause c = new Clause();
		Environment e = new Environment();
		for(int i=0; i<1000; i++)
		{
			Literal l = new Literal(i);
			e.add(i, Bool.TRUE);
			c.add(l);
		}
		Literal l = new Literal(1000);
		e.add(1000, Bool.FALSE);
		c.add(l);
		assertEquals(c.eval(e), Bool.TRUE);
	}	

}
