package music;

import java.util.ArrayList;
import music.*;

public class Chord extends Elem implements MusicElement{

	public ArrayList<Note> notes;
	
	public Chord()
	{
		notes = new ArrayList<Note>();
	}
	
	public void addNote(Pitch pitch, double length, Accidental a)
	{
		notes.add(new Note(pitch, length, a));
	}
	
	public void addNote(Note n)
	{
		notes.add(n);
	}
	
	public double duration()
	{
		double duration = 0, maxDuration = 0;
		for(Note n : notes)
		{
			duration = n.duration();
			if(duration > maxDuration)
				maxDuration = duration;
		}
		return(maxDuration);
	}	
	
	public void print()
	{
		System.err.print("[");
		for(Note n: notes)
			n.print();
		System.err.print("]");
	}
	
	@Override
	public void accept(MusicVisitor v)
	{
		v.visit(this);
	}	
	
}
