package music;

import music.*;

public class Note extends Elem implements MusicElement{
	
	public double length;
	public Pitch pitch;
	public Accidental accidental;
	
	public Note(Pitch thePitch, double theLength, Accidental a)
	{
		pitch = thePitch;
		length = theLength;
		accidental = a;
	}
	
	public double duration()
	{
		return length;
	}
	
	public void print()
	{
		switch(accidental)
		{
		case DOUBLEFLAT: System.err.print("__");break;
		case DOUBLESHARP: System.err.print("^^");break;
		case FLAT: System.err.print("_");break;
		case SHARP: System.err.print("^");break;
		case NATURAL: System.err.print("=");break;
		}
		
		System.err.print((char)pitch.toneToNote()[0]);
		
		for(int i = 0; i<pitch.toneToNote()[1]/12; i++)
			System.err.print("'");
		for(int i = 0; i>pitch.toneToNote()[1]/12; i--)
			System.err.print(",");
		
		System.err.printf("(%.1f)", length);
	}

	@Override
	public void accept(MusicVisitor v)
	{
		v.visit(this);
	}	
	
}
