package music;

import music.*;
import java.util.ArrayList;

public class Tuplet extends Elem implements MusicElement{

	public ArrayList<Note> notes;
	
	public Tuplet()
	{
		notes = new ArrayList<Note>();
	}
	
	public void addNote(Note n)
	{
		notes.add(n);
	}
	
	/**
	 * Scales the durations of the component notes for
	 * duplets, triplets and quadruplets
	 */
	public void resize()
	{
		double duration = 1.0;
		switch(notes.size())
		{
		case 2: duration = 1.5; break;
		case 3: duration = 2.0/3.0; break;
		case 4: duration = .75; break;
		default: System.err.printf("Warning tuplet has %d elements.\n", notes.size()); break;
		}
		for(Note n : notes)
			n.length *= duration;
	}
	
	public double duration()
	{
		double duration = 0;
		for(Note n : notes)
		{
			duration += n.duration();
		}
		return(duration);
	}
	
	public void print()
	{
		System.err.printf("(%d", notes.size());
		for(Note n: notes)
			n.print();
	}
	
	@Override
	public void accept(MusicVisitor v)
	{
		v.visit(this);
	}	
}
