package model;

public class Message {

	private String alias;
	private String text;
	
	public Message(String a, String t)
	{
		alias = a;
		text = t;
	}
	
	@Override
	public String toString()
	{
		return(alias+": "+text);
	}
	
	/**
	 * Replaces any '[' or ']' with '(', ')' to ensure no protocol mishaps
	 * @param text
	 * @return
	 */
	public static String makeSafe(String text)
	{
		text = text.replaceAll("\\[", "(");
		text = text.replaceAll("\\]", ")");
		text = text.replaceAll("`", "'");
		return(text);
	}
}
